<cfimport prefix="layout" taglib="./layout" />
<layout:layout>
<cfscript>
	collection = application.mongo.getDBCollection( "sessions" );

	param name="url.PRESENTER" default="";
	findCriteria = {"PRESENTER" = url.PRESENTER };
	sortCriteria = {"PRESENTATION"=1};

	SessionArray = collection.find(criteria=findCriteria, sort=sortCriteria).asArray();
</cfscript>
<cfoutput>
<h1>#SessionArray[1].PRESENTER#</h1>
<ul>
	<cfloop array="#SessionArray[1].CONTACT#" index="thisContact">
		<li>#thisContact#</li>
	</cfloop>
</ul>
<cfloop array="#SessionArray#" index="thisSession">
	<h2>#thisSession.PRESENTATION#</h2>
	<h4>Track: <a href="TrackSessionList.cfm?TRACK=#thisSession.TRACK#">#thisSession.TRACK#</a></h4>
	<p>#thisSession.PRESENTATION_DESCRIPTION#</p>
	<p><a data-toggle="modal" data-id="#thisSession._id#" data-presenter="#thisSession.PRESENTER#" href="##myModal" class="btn btn-primary openFeedbackForm">Leave Feedback On This Session</a></p>

	<cfif structKeyExists( thisSession, "COMMENTS") AND isArray(thisSession.COMMENTS )>
		<h5>Feedback</h5>
		<ul>
			<cfloop array="#thisSession.COMMENTS#" index="thisComment">
				<li><span class="badge">#thisComment.RATING#</span>: #thisComment.COMMENT#</li>
			</cfloop>
		</ul>
	</cfif>
</cfloop>
</cfoutput>
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
				<h4 class="modal-title">Submit your feedback on this session</h4>
			</div>
			<div class="modal-body">
				<form id="FeedbackForm" role="form" action="HandleSessionFeedback.cfm" method="post">
					<div class="form-group">
						<label for="inputEmail1">Rating</label>
						<div class="radio">
							<div class="radio">
								<label>
									<input type="radio" name="rating" id="rating1" value="1"> Poor
								</label>
                                <span class="help-block">Was this speaker: was unprepared, not very knowledgeable, just plain bad?</span>
							</div>
							<div class="radio">
								<label>
									<input type="radio" name="rating" id="rating2" value="2" checked> Good
								</label>
								<span class="help-block">Was this speaker good enough?</span>
							</div>
							<div class="radio">
								<label>
									<input type="radio" name="rating" id="rating3" value="3"> Excellent
								</label>
								<span class="help-block">Was this speaker amazing? Would you listen to this speaker read the phone book?</span>
							</div>
						</div>
					</div>
					<div class="form-group">
						<label for="inputPassword1">Your Comments:</label>
						<div class="textarea">
							<textarea class="x" name="Comment"></textarea>
						</div>
					</div>
					<div class="form-group">
						<div class="col-lg-offset-2 col-lg-10">
							<input type="hidden" id="SessionID" name="_id" value="" />
							<input type="hidden" id="Presenter" name="Presenter" value="" />
							<button type="submit" class="btn btn-default">Submit Your Feedback</button>
						</div>
					</div>
				</form>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
			</div>
		</div>
		<!-- /.modal-content -->
	</div>
	<!-- /.modal-dialog -->
</div><!-- /.modal -->
<script>
	$(document).on("click", ".openFeedbackForm", function () {
		 $("#SessionID").val( $(this).data('id') );
		 $("#Presenter").val( $(this).data('presenter') );
	});
</script>
</layout:layout>
